



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ5290 &amp; 洛谷4438：[HNOI/AHOI2018]道路——题解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ5290 &amp; 洛谷4438：[HNOI/AHOI2018]道路——题解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 20:30:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://www.lydsy.com/JudgeOnline/problem.php?id=5290" rel="external nofollow noreferrer">https://www.lydsy.com/JudgeOnline/problem.php?id=5290</a></p>
<p><a href="https://www.luogu.org/problemnew/show/P4438" rel="external nofollow noreferrer">https://www.luogu.org/problemnew/show/P4438</a></p>
<p>的确不是很难的题。</p>
<p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;</p>
<p>先是吐槽时间（可略过）：</p>
<p>设f[i][j][k]为以i为根的子树中j公路不修k铁路不修的最小值。</p>
<p>然后dfs就能过&hellip;&hellip;不过貌似我想的dfs可能要存很多东西&hellip;&hellip;觉得正解肯定没有那么麻烦，于是就弃疗了。</p>
<p>&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;</p>
<p>设f[i][j][k]表示i子树叶子到1节点路程j公路不修k铁路不修的最小值。</p>
<p>那么设l=s[u],r=t[u],则f[u][i][j]=min(f[l][i+1][j]+f[r][i][j],f[l][i][j]+f[r][i][j+1]);</p>
<p>当然f数组很大，不过发现一些状态用完了就没有了，所以可以垃圾回收一下。</p>
<div>
<pre class="prettyprint linenums">#include&lt;cmath&gt;<br />
#include&lt;stack&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cctype&gt;<br />
#include&lt;cstdlib&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
typedef long long ll;<br />
const ll INF=1e18;<br />
const int N=4e4+;<br />
inline int read(){<br />
    int X=,w=;char ch=;<br />
    while(!isdigit(ch)){w|=ch=='-';ch=getchar();}<br />
    while(isdigit(ch))X=(X&lt;&lt;)+(X&lt;&lt;)+(ch^),ch=getchar();<br />
    return w?-X:X;<br />
}<br />
int n,tot,s[N],t[N],dfn[N];<br />
ll a[N],b[N],c[N],f[][][];<br />
stack&lt;int&gt;bin;<br />
void dfs(int u,int x,int y){<br />
    if(u&lt;n){<br />
    dfs(s[u],x+,y);dfs(t[u],x,y+);<br />
    }<br />
    if(bin.empty())dfn[u]=++tot;<br />
    else{dfn[u]=bin.top();bin.pop();}<br />
    if(u&lt;n){<br />
    bin.push(dfn[s[u]]);bin.push(dfn[t[u]]);<br />
    }else{<br />
    for(int i=;i&lt;=;i++)<br />
        for(int j=;j&lt;=;j++)<br />
        f[dfn[u]][i][j]=c[u]*(a[u]+i)*(b[u]+j);<br />
    return;<br />
    }<br />
    int l=dfn[s[u]],r=dfn[t[u]],k=dfn[u];<br />
    for(int i=;i&lt;=x;i++)<br />
    for(int j=;j&lt;=y;j++)<br />
        f[k][i][j]=min(f[l][i+][j]+f[r][i][j],f[l][i][j]+f[r][i][j+]);<br />
}<br />
int main(){<br />
    n=read();<br />
    for(int i=;i&lt;n;i++){<br />
    s[i]=read(),t[i]=read();<br />
    if(s[i]&lt;)s[i]=-s[i]+n;<br />
    if(t[i]&lt;)t[i]=-t[i]+n;<br />
    }<br />
    for(int i=;i&lt;=n;i++)a[i+n]=read(),b[i+n]=read(),c[i+n]=read();<br />
    dfs(,,);<br />
    printf("%lld\n",f[dfn[]][][]);<br />
    return ;<br />
}</pre>
</div>
<p>+++++++++++++++++++++++++++++++++++++++++++</p>
<p>+本文作者：luyouqi233。 　　　　　　　　　　　　　　+</p>
<p>+欢迎访问我的博客：<a href="http://www.cnblogs.com/luyouqi233/" rel="external nofollow noreferrer">http://www.cnblogs.com/luyouqi233/</a>+</p>
<p>+++++++++++++++++++++++++++++++++++++++++++</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gmvlz9.html">UVA 11235Frequent values&lpar;RMQ&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gdzme9.html">我需要在Web上完成一个图片上传的功能后续&lpar;&plus;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq14k62q.html">C&plus;&plus;设计模式-State状态模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy6jjx8.html">hadoop rpc基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzllpq.html">ArcGIS 帮助（10&period;2、10&period;2&period;1 和 10&period;2&period;2）收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzoj08.html">&lbrack;IT扫盲&rsqb;软件测试时期版本的称呼</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k3427q.html">使用多种客户端消费WCF RestFul服务&lpar;四&rpar;&mdash;&mdash;Jquery篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11lp39.html">使用分布式数据库集群做大数据分析之OneProxy</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1z64d9.html">WPF - 这是一堆代码片段的集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjrzrk9.html">SQL SERVER 自带系统存储过程分类</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wp5koq.html">first day for new job</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvx5gyq.html">hdu 1050 Moving Tables&lowbar;贪心</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj4l0eq.html">SharePoint&colon;备份和还原</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpkv0j9.html">Bash 脚本进阶，经典用法及其案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8merlm0q.html">LINUX 笔记-watch命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25xgnxq.html">python functools&period;wraps  functools&period;partial实例解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy4g3d9.html">URAL 1099 Work Scheduling &lpar;一般图最大匹配&rpar; 模板题【带花树】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j2ln0q.html">C&plus;&plus; code：main参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvpvek8.html">windows下端口映射（端口转发）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6d748.html">Django之连接远程mysql数据库</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kmo7739.html">MySQL数据库优化方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mdj14r8.html">Linux命令应用大词典-第21章 LVM和RAID管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy2vmnm9.html">【system&period;string】使用说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/q44pxdnq.html">DNA序列 （DNA Consensus String&comma;ACM&sol;ICPC Seoul 2006&comma;UVa1368</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zvkmmv9.html">JavaScript 正则</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnddmxk8.html">压力测试工具-webbench</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlooe66q.html">Java抽象与接口的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qloomv1q.html">svn升级&lpar;mac&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxllkdjq.html">Python练习&mdash;&mdash;循环2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oddjpxq.html">c&num;  两个软件传参</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
